**Aufgabe**  
Gegeben: Graph, series-parallel, bis 10⁶ Knoten  
Gesucht: Max-Cut zwischen Start und Endknoten, so dass der Graph in genau (!) zwei Komponenten zerfällt

**Format des Graphen**  
- `()` ist der Graph mit einer Kante und ihren beiden Endknoten  
- `() + ()` -> beide Kanten werden hintereinander gehängt -> Pfad mit zwei Kanten  
- `() \* ()` -> Kanten werden parallelisiert -> vordere Endpunkte werden zusammengelegt, hintere Endpunkte werden zusammengelegt  
- + und \* können auch komplexere Terme verbinden. Beispiel: (((() + ()) \* ()) + ())  

Mit dieser Prozedur können auch Multigraphen erstellt werden. Diese sind in der Aufgabe auch erlaubt.  
Bilder und anders formulierte Erklärung: Siehe https://en.wikipedia.org/wiki/Series%E2%80%93parallel_graph  


**Lösung**  
Eine Kante hat Cut der Größe 1. Werden Graphen aneinander gehängt (+ Operation) nimmt man das Maximum der Serie. Entstehen parallele Strukturen (\* Operation) addiert man die bisherigen Größen der Cuts.

Anders gesagt: Ersetze jedes leere Klammerpaar durch eine 1, ersetze + durch max, \* durch + und rechne den entstehenden Term aus.

**Schwierigkeit**  
60  

**Variationen**  
nicht die rekursive Darstellung geben sondern normale Graphdarstellung z.B. über Kantenliste. Informationen zur Graphklasse müssen trotzdem gegeben werden, aber zusätzliche Schwierigkeit des Berechnens der rekursiven Darstellung. (vermutlich deutlich schwieriger)

**Input**  
Graph in obiger Darstellung (String aus (, ), +, \*). alle Klammern vorhanden, kein Leerzeichen  

**Output**  
Maxcut im gegebenen Graphen

**Samples** (Leerzeichen zur Lesbarkeit hinzugefügt)  
**Sample 1**  
Input: (() + (()\*(() + ())))  
Term: max(1, (1 + max(1,1)))  
Output: 2

**Sample 2**  
Input: (((() + ()) \* ()) \* ((() + (((() + ()) \* ()) \* ())) + ()))  
Term: max(1,1) + 1 + (max(1, (max(1,1) + 1 + 1), 1))  
Output: 5

