#include <iostream>
#include <cassert>
#include <tuple>

using namespace std;

using ll = long long;

using Parse = pair<ll, string_view>;

Parse go(string_view s) {
	assert(s[0] == '(');
	if(s[1] == ')')
		return Parse(1, s.substr(2));
	ll left,right;
	tie(left, s) = go(s.substr(1));
	const char op = s[0];
	assert(op == '*' || op == '+');
	tie(right, s) = go(s.substr(1));
	return Parse(op == '+' ? max(left, right) : (left + right), s.substr(1));
} 

int main() {
	ios::sync_with_stdio(0), cin.tie(0);
	string s;
	cin >> s;
	cout << go(s).first << endl;
}
