#include <iostream>
#include <iomanip>
#include <cmath>
using namespace std;
const double EPS = 1e-8;

double binSearch(double area, double x) {
	double low = 0;
	double up = 2 * x * sin(M_PI/8);
	while (up - low > EPS) {
		double mid = (low + up) / 2;
		double a = 4 * mid * sqrt(x * x - mid * mid / 4);
		if (a > area) up = mid;
		else low = mid;
	}
	return low;
}

int main() {
	double a, x; cin >> a >> x;
	double max_d = 2*x * sin(M_PI/8);
	double max_h = sqrt(x*x - max_d*max_d/4);
	double max_dry = 4*max_d*max_h;
	if (max_dry <= a) {
		cout << setprecision(10) << fixed << max_dry << endl;
		return 0;
	}
	double d = binSearch(a,x);
	double r = d / 2 / tan(M_PI / 8);
	double dry = 4 * d * r;
	cout << setprecision(10) << fixed << dry << endl;
}
