#include "validation.h"
#include "numbers.h"

#include <iostream>
using namespace std;

using i64 = long long;

const int X = 1000;

int main(int argc, char **argv) {
	ifstream in(argv[1]);
	OutputValidator v(argc, argv);

	int n, k;
	in >> n >> k;

	vector<circle> circles(n);

	if (k > n*(n-1)) {
		v.test_string("impossible");
		v.newline();
		return 0;
	}

	for (auto &c: circles) {
		c.x = v.read_integer("x", -X, X);
		v.space();
		c.y = v.read_integer("y", -X, X);
		v.space();
		c.r = v.read_integer("r",  1, X);
		v.newline();
	}
	
	set<circle> circles_set(begin(circles), end(circles));
	v.check(size(circles_set) == n, "Circles must be distinct.");
	
	vector<intersection> intersections;
	for (int i = 0; i < n; i++) {
		for (int j = 0; j < i; j++) {
			intersect(circles[i], circles[j], intersections);
		}
	}
	
	int count = 0;
	for (int i = 0; i < size(intersections); i++) {
		bool found = false;
		for (int j = 0; j < i; j++) {
			if (intersections[i] == intersections[j]) found = true;
		}
		if (!found) {
			auto [x,y] = intersections[i];
			cerr << "(" << x << " | " << y << ")" << endl;
			count++;
		}
	}
	
	v.check(count == k, "Incorrect number of intersection points: ", count, ".");
}
